async function load_tilesection_2(section_index) {

    showTileExplorerSpinner();

    var section_index = section_index || document.getElementById("tile_explorer_section_selection").value;

    section_index = parseInt(section_index);

    var section = tile_explorer_data.map.directory.sections[tile_explorer_data.map.directory.section_indices.indexOf(section_index)];

    var buffer = new InterpretationBuffer(section.get_data().buffer);

    var denominator = 80400;
    var datasize = buffer.size / denominator;


    if (datasize == 2) {
        var data = buffer.readShorts(80400);
    } else if (datasize == 1) {
        var data = buffer.readBytes(80400);
    } else if (datasize == 4) {
        var data = buffer.readInts(80400);
    } else {
        if (datasize == 9) {
            alert("Sorry, this explorer currently does not support this section")
        }
        throw `invalid datasize, are you sure it is a proper tilesection? ${datasize}`
    }
    var element = document.querySelector('#datadog');
    var pElem = document.createElement('p');
    pElem.className = 'styleforP';
    pElem.innerHTML = 'Start:\n';
    data.forEach(function (value, index) {
        var p = new TileIndex(index).to_serialized_point().to_adjusted_point();
        pElem.innerHTML += "tileheight[" + p.i + "][" + p.j + "] = " + value + "\n";
    })
    element.appendChild(pElem);
}